import { BaseQuery } from './BaseQuery';
import { ParamAllocator } from './ParamAllocator';
declare class MssqlParamAllocator extends ParamAllocator {
    paramPlaceHolder(paramIndex: any): string;
}
export declare class MssqlQuery extends BaseQuery {
    newFilter(filter: any): any;
    castToString(sql: any): string;
    concatStringsSql(strings: string[]): string;
    convertTz(field: any): string;
    timeStampCast(value: string): string;
    dateTimeCast(value: string): string;
    timeGroupedColumn(granularity: string, dimension: string): string;
    /**
     * Returns sql for source expression floored to timestamps aligned with
     * intervals relative to origin timestamp point.
     * The formula operates with seconds diffs so it won't produce human-expected dates aligned with offset date parts.
     */
    dateBin(interval: string, source: string, origin: string): string;
    newParamAllocator(expressionParams: any): MssqlParamAllocator;
    groupByDimensionLimit(): string;
    topLimit(): string;
    /**
     * Overrides `BaseQuery#groupByClause` method and returns `GROUP BY` clause
     * with the column names instead of column numeric sequences as MSSQL does
     * not support this format.
     * @returns {string}
     * @override
     */
    groupByClause(): string;
    /**
     * Overrides `BaseQuery#aggregateSubQueryGroupByClause` method and returns
     * `GROUP BY` clause for the "aggregating on top of sub-queries" uses cases.
     * @returns {string}
     * @override
     */
    aggregateSubQueryGroupByClause(): string;
    overTimeSeriesSelect(cumulativeMeasures: any, dateSeriesSql: any, baseQuery: any, dateJoinConditionSql: any, baseQueryAlias: any): string;
    nowTimestampSql(): string;
    unixTimestampSql(): string;
    preAggregationLoadSql(cube: any, preAggregation: any, tableName: any): any[];
    wrapSegmentForDimensionSelect(sql: any): string;
    seriesSql(timeDimension: any): string;
    subtractInterval(date: string, interval: string): string;
    addInterval(date: string, interval: string): string;
    sqlTemplates(): any;
}
export {};
//# sourceMappingURL=MssqlQuery.d.ts.map